# Coveo DynamicFacetManager Component (CoveoDynamicFacetManager)

The `DynamicFacetManager` component is meant to be a parent for multiple DynamicFacet & DynamicFacetRange components. This component allows controlling a set of `DynamicFacet` and `DynamicFacetRange` as a group.

Available since

  May 2019 Release (v2.6063)

Additional documentation

  Using Dynamic Facets.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- compareFacets
- enableReorder
- maximumNumberOfExpandedFacets
- onUpdate

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### compareFacets

compareFacets: IDynamicFacetManagerCompareFacet

- Defined in ui/DynamicFacetManager/DynamicFacetManager.ts :90

A custom sort function to execute on facets on every successful query response @externaldocs Using Custom Dynamic Facet Sort Functions.

Note:

> If specified, the function must implement the JavaScript compareFunction (see Array.prototype.sort. You cannot set this option directly in the component markup as an HTML attribute. You must either set it in the `init` call of your search interface (see Passing Component Options in the init Call), or before the `init` call, using the `options` top-level function (see Passing Component Options Before the init Call).

### enableReorder

enableReorder: boolean

- Defined in ui/DynamicFacetManager/DynamicFacetManager.ts :65

Whether to allow the reordering of facets based on Coveo ML and index ranking scores.

Default: `true`

Default

  `true`

Markup configuration example(s) :

    data-enable-reorder='true'
    data-enable-reorder='false'

### maximumNumberOfExpandedFacets

maximumNumberOfExpandedFacets: number

- Defined in ui/DynamicFacetManager/DynamicFacetManager.ts :105

The maximum number of expanded facets inside the manager. Remaining facets are collapsed.

Note: Prioritizes facets with active values, and then prioritizes first facets. If the number of facets with active values exceeds the value of the `maximumNumberOfExpandedFacets` option, it overrides the option.

Using the value `-1` disables the feature and keeps all facets expanded.

Default

  `4`

Available since

  September 2019 Release (v2.7023)

Markup configuration example(s) :

    data-maximum-number-of-expanded-facets='10'

### onUpdate

onUpdate: IDynamicFacetManagerOnUpdate

- Defined in ui/DynamicFacetManager/DynamicFacetManager.ts :76

A function to execute whenever facets are updated in the query response @externaldocs Defining Custom Dynamic Facet Behaviors.

Note:

> You cannot set this option directly in the component markup as an HTML attribute. You must either set it in the `init` call of your search interface (see Passing Component Options in the init Call), or before the `init` call, using the `options` top-level function (see Passing Component Options Before the init Call).

## Constructors

### constructor

- new DynamicFacetManager(element: HTMLElement, options?: IDynamicFacetManagerOptions): DynamicFacetManager

- Overwrites Component.constructor

  - Defined in ui/DynamicFacetManager/DynamicFacetManager.ts :117

  Creates a new `DynamicFacetManager` instance.

  #### Parameters

  - ##### element: HTMLElement

    The element from which to instantiate the component.

  - ##### Optional options: IDynamicFacetManagerOptions

    The component options.

  #### Returns DynamicFacetManager